Subject: [bug#68498] [PATCH] guix-install.sh: Make Guix modules available too.

From: Janneke Nieuwenhuizen <[email-masked]>
Date: Mon, 29 Jan 2024 12:54:21 +0100

Ludovic Courtès writes:

Hello,

> Janneke Nieuwenhuizen <[email-masked]> skribis:
>
>>>> +# Make Guix modules available
>>>> +export
>>>> GUILE_LOAD_PATH="$_GUIX_PROFILE/share/guile/site/3.0${GUILE_LOAD_PATH:+:}$GUILE_LOAD_PATH"
>>>> +export
>>>> GUILE_LOAD_COMPILED_PATH="$_GUIX_PROFILE/lib/guile/3.0/site-ccache${GUILE_LOAD_COMPILED_PATH:+:}$GUILE_LOAD_COMPILED_PATH"
>>>
>>> My inclination would be to let people just use ‘guix repl’, but maybe
>>> that’s not satisfactory or convenient?  WDYT?
>>
>> The intention is to have the foreign distro experience resemble Guix
>> System more, esp. for newbee users.  If you have a code base that uses
>> Guix modules and comes with a guix.scm, running "guix shell" doesn't
>> work for them.  Unless, maybe, you add "guix" to the package's
>> native-inputs -- yuck.
>
> Packages that extend Guix functionality, like Cuirass and hpcguix-web,
> have ‘guix’ in their inputs.  That’s fine: they use just the core (guix …)
> modules to interact with the store etc.
>
> Is that what the kind of use case you had in mind?

Yes.  I always believed this was a big no-no, but adding guix to the
packages' inputs in guix.scm would also work.

>> They'd have to probably do something guix time-machine --channel=xxx to
>> get access to guix modules.  That, or source a script that set the
>> environment variables, which is what we let them do currently.  I was
>> guessing "everyone" is probably fighting with this, so finally decided
>> to upstream it :)
>>
>> If there's a better/easier solution for this, I'm all ears!
>
> I don’t think one needs ‘guix time-machine’; ‘guix repl’ is enough to
> get access to Guix modules.

Yeah, but as stated above, it was to setup a (configure) shell, so...

I'm still somewhat puzzled about why setting GUILE_LOAD[_COMPILED]_PATH
would be a bad idea, but unless someone else decides to chimes some time
soon in I guess we can close this bug.

Greetings,
Janneke

-- 
Janneke Nieuwenhuizen <[email-masked]>  | GNU LilyPond https://LilyPond.org
Freelance IT https://www.JoyOfSource.com | Avatar® https://AvatarAcademy.com